//+------------------------------------------------------------------+
//|                                                          ATR.mq4 |
//|                      Copyright  2005, MetaQuotes Software Corp. |
//|                                       http://www.metaquotes.net/ |
//+------------------------------------------------------------------+
#property copyright "Copyright  2005, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net/"

#property indicator_separate_window
#property indicator_buffers 1
#property indicator_color1 DodgerBlue
//---- input parameters
//---- buffers
double Risk[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
   string short_name;
//---- 1 additional buffer used for counting.
   IndicatorBuffers(1);
//---- indicator line
   SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexBuffer(0,Risk);
//---- name for DataWindow and indicator subwindow label
   short_name="Risk";
   IndicatorShortName(short_name);
   SetIndexLabel(0,short_name);
//----
   SetIndexEmptyValue(0,0);
   IndicatorDigits(Digits-1);
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Average True Range                                               |
//+------------------------------------------------------------------+
int start()
  {
   int i,counted_bars=IndicatorCounted();
//----
//
//ʷͳ
   OrderSelect(0,SELECT_BY_POS,MODE_HISTORY);
   i=iBarShift(Symbol(),Period(),OrderOpenTime());
//
   while(i>=0)
     {
      double preLoss=0; Risk[i]=0; int lossAll=0;
//
      for(int j=1;j<=HistoryTotal()-1;j++)                 //Զ
      {
       if(OrderSelect(j,SELECT_BY_POS,MODE_HISTORY)==false)     break;
//
       if(OrderClosePrice()==0) continue;
//
       int openPos=iBarShift(Symbol(),Period(),OrderOpenTime());
       if(openPos<i) break;
//
       int closePos=iBarShift(Symbol(),Period(),OrderCloseTime());
       if(closePos>i) continue;
//
       if(OrderType()==OP_BUY) int dir=1;
       if(OrderType()==OP_SELL) dir=-1;
       if(OrderStopLoss()==0)
       {lossAll=1; break;
       }
       else if(dir!=0)
       {preLoss=dir*(100*OrderOpenPrice()-100*OrderStopLoss());
        if(preLoss>0)
        {
         if(StringFind(OrderSymbol(),"JPY",0)==-1) preLoss*=100;
         if(StringFind(OrderSymbol(),"GOLD",0)==0) double value=1; //ÿֵ
         else value=10;
//Print(OrderTicket(),"  ",OrderSymbol(),"  ",preLoss,"  ",OrderLots());
         Risk[i]+=preLoss*value*OrderLots();
        }
       }
//
      }
//
      if(lossAll==1) Risk[i]=100;
      else
      {double balance=iCustom(NULL,0,"balance",0,i+1);
       Risk[i]*=100/balance;
      }
      i--;
     }
//
//δͳ
   OrderSelect(0,SELECT_BY_POS,MODE_TRADES);
   i=iBarShift(Symbol(),Period(),OrderOpenTime());
//
   while(i>=0)
     {
      preLoss=0;
//
      for(j=0;j<=OrdersTotal()-1;j++)                 //Զ
      {
       if(OrderSelect(j,SELECT_BY_POS,MODE_TRADES)==false)     break;
//
       openPos=iBarShift(Symbol(),Period(),OrderOpenTime());
       if(openPos<i) break;
//
       if(OrderType()==OP_BUY) dir=1;
       if(OrderType()==OP_SELL) dir=-1;
       if(OrderStopLoss()==0)
       {Risk[i]=100; break;
       }
       else if(dir!=0)
       {preLoss=dir*(100*OrderOpenPrice()-100*OrderStopLoss());
        if(preLoss>0)
        {
         if(StringFind(OrderSymbol(),"JPY",0)==-1) preLoss*=100;
         if(StringFind(OrderSymbol(),"GOLD",0)==0) value=1; //ÿֵ
         else value=10;
         balance=iCustom(NULL,0,"balance",0,i+1);
         Risk[i]+=preLoss*value*OrderLots()*100/balance;
        }
       }
      }
//
      i--;
     }
//
   return(0);
  }
//+------------------------------------------------------------------+